local print = print
local ipairs = ipairs
local io = io
local os = os

local oop = require "loop.base"

---
-- Classe que representa o visualizador dos resultados dos testes em console
--
module("latt.ConsoleResultViewer", oop.class)

---
-- O construtor do visualizador
--
-- @param self O prprio visualizador
-- @param result O resultado a ser exibido
--
function __new(self, result)
  return oop.rawnew(self, { result = result, })
end

---
-- Exibe um resultado no console
--
-- @param self O prprio visualizador
--
function show(self)
  print("==============================================")
  print("LATT (Lua Automated Testing Tool)           \n")
  print("Time: "..os.difftime(self.result.stopTime, self.result.startTime).." second(s)\n")
  if self.result.failureCounter ~= 0 then
    print("There were "..self.result.failureCounter.." failure(s):")
    for i, failure in ipairs(self.result.failures) do
      print(i..") "..failure.testCaseName.." - "..failure.testName)
      print(failure.errorMessage.."\n")
    end
    print("FAILURES!!!")
    print("Tests run: "..self.result.testCounter..",  Failures: "..self.result.failureCounter.."")
  else
    print("OK ("..self.result.testCounter.." tests)")
  end
  print("==============================================")
end
