if #arg < 1 then
  io.stdout:write("Use: lua ConsoleTestRunner.lua [-verbose] <test_suite_file_name>"
      .." [test_name_1] [test_name_2] ... [test_name_n]\n")
  os.exit(1)
end

local verbose = false
for i = 1, #arg do
  if arg[i] == "-verbose" or arg[i] == "-v" then
    verbose = true
    table.remove(arg,i)
    break
  end
end

local suiteFileName = arg[1]
assert(loadfile(suiteFileName))()
if not Suite then
  io.stderr:write("No suite in file "..suiteFileName.."\n")
  os.exit(1)
end

if not Suite.name then
  Suite.name = suiteFileName
end

local tests = {}
for i = 2, #arg do
  tests[arg[i]] = true
end

local TestRunner = require("latt.TestRunner")
local ConsoleResultViewer = require("latt.ConsoleResultViewer")

local testRunner = TestRunner(Suite, tests)
local result = testRunner:run(verbose)
local viewer = ConsoleResultViewer(result)
viewer:show()

if result.failureCounter ~= 0 then
  os.exit(1)
end
