local ipairs = ipairs

local oop = require "loop.base"

local TestResult = require "latt.TestResult"

---
-- Classe que representa uma sute de testes
--
module("latt.TestSuite", oop.class)

---
-- @param self
-- @param name
-- @param testCase
--
function __new(self, name, testCases)
  return oop.rawnew(self, { name = name, testCases = testCases, })
end

---
-- @param self
--
function run(self, verbose)
  local result = TestResult(self.name, verbose)
  result:startTestSuite()
  for _, testCase in ipairs(self.testCases) do
    testCase:run(result)
  end
  result:stopTestSuite()
  return result
end
